package com.maroontress.madangler.client.config;

import com.google.gwt.user.client.ui.Button;
import com.google.gwt.user.client.ui.ClickListener;
import com.google.gwt.user.client.ui.HTML;
import com.google.gwt.user.client.ui.HorizontalPanel;
import com.google.gwt.user.client.ui.PopupListener;
import com.google.gwt.user.client.ui.PopupPanel;
import com.google.gwt.user.client.ui.VerticalPanel;
import com.google.gwt.user.client.ui.Widget;
import com.maroontress.madangler.client.MadAngler;
import com.maroontress.madangler.client.Dialog;
import com.maroontress.madangler.client.TextBoxPanel;

/**
   ץåȥեɲäΥǤ
*/
public class PlatformDialog extends Dialog {

    /** 󥻥Υܥ */
    private Button cancelButton;

    /** Υܥ */
    private Button okButton;

    /** ʸå̾ */
    private CharsetListBox charset;

    /** ץΥǥ */
    private ConfigModel model;

    /** ⡼ȥޥ */
    private TextBoxPanel command;

    /** 桼@ۥ̾ */
    private TextBoxPanel host;

    /** ץåȥեID */
    private TextBoxPanel id;

    /**
       ץåȥեɲäΥޤ

       @param model ץΥǥ
    */
    public PlatformDialog(final ConfigModel model) {
	this.model = model;

	setText("Add a new platform");

	id = new TextBoxPanel("Platform ID", 32);
	host = new TextBoxPanel("User@Hostname", 64);
	command = new TextBoxPanel("Command", 64);
	charset = new CharsetListBox();

	cancelButton = new Button("Cancel");
	cancelButton.addClickListener(new ClickListener() {
	    public void onClick(final Widget sender) {
		hide();
	    }
	});

	okButton = new Button("Ok");
	okButton.addClickListener(new ClickListener() {
	    public void onClick(final Widget sender) {
		addPlatform();
	    }
	});

	HorizontalPanel bp = new HorizontalPanel();
	HTML space = new HTML("&nbsp;");
	bp.add(cancelButton);
	bp.add(space);
	bp.add(okButton);
	bp.setCellWidth(space, "100%");
	bp.setWidth("100%");

	VerticalPanel vp = new VerticalPanel();
	vp.add(new HTML("&nbsp;"));
	vp.add(id);
	vp.add(new HTML("&nbsp;"));
	vp.add(host);
	vp.add(new HTML("&nbsp;"));
	vp.add(command);
	vp.add(new HTML("&nbsp;"));
	vp.add(new HTML("Charset"));
	vp.add(charset);
	vp.add(new HTML("&nbsp;"));
	vp.add(bp);

	setWidget(vp);

	addPopupListener(new PopupListener() {
	    public void onPopupClosed(final PopupPanel panel,
				      final boolean b) {
		id.setText("");
		host.setText("");
		command.setText("");
		charset.setSelectedIndex(0);
	    }
	});
    }

    /**
       ʸζޤ

       ζʸ󤬶ξϥǷٹ𤷡
       null֤ޤ

       @param s ζʸ
       @param label ٹ𤹤ȤɽʸΥ٥
       @return ʸ󡢷̤ξnull
    */
    private String trim(final String s, final String label) {
	String t = s.trim();
	if (t.equals("")) {
	    MadAngler.alert(label + " is empty.");
	    return null;
	}
	return t;
    }

    /**
       ץåȥեɲäޤ
    */
    private void addPlatform() {
	String idString = trim(id.getText(), "Platform ID");
	String hostString = trim(host.getText(), "User@Hostname");
	String commandString = trim(command.getText(), "Command");
	String charsetString = charset.getSelectedValue();
	if (idString == null || hostString == null || commandString == null) {
	    return;
	}
	if (model.getPlatformById(idString) != null) {
	    MadAngler.alert("'" + idString + "' already exists.");
	    return;
	}
	Platform p = new Platform(idString, hostString, commandString,
				  charsetString);
	model.addPlatform(p);
	model.notifyChanged();
	hide();
    }
}
